From 219fb73cd923bdbc6ebe47a1b67b97578a1536e9 Mon Sep 17 00:00:00 2001
From: Wei Gao <gaowei66@huawei.com>
Date: Wed, 15 Jul 2020 22:19:37 -0400
Subject: [PATCH] kata-runtime: add support of new sandbox quantvisor.

Signed-off-by: Wei Gao <gaowei66@huawei.com>
---
 pkg/katautils/config.go                            |   4 +
 .../agent/protocols/grpc/agent.pb.go               | 853 +++++++++++++++------
 virtcontainers/agent.go                            |   8 +
 virtcontainers/hypervisor.go                       |   9 +
 virtcontainers/kata_agent.go                       |  29 +
 virtcontainers/noop_agent.go                       |   9 +
 virtcontainers/quantvisor.go                       | 687 +++++++++++++++++
 virtcontainers/sandbox.go                          |  14 +
 virtcontainers/types/capabilities.go               |  11 +
 virtcontainers/vm.go                               |  11 +
 10 files changed, 1401 insertions(+), 234 deletions(-)
 create mode 100644 virtcontainers/quantvisor.go

diff --git a/pkg/katautils/config.go b/pkg/katautils/config.go
index 9105bc6..f98b3cb 100644
--- a/pkg/katautils/config.go
+++ b/pkg/katautils/config.go
@@ -51,6 +51,7 @@ const (
 	// supported hypervisor component types
 	firecrackerHypervisorTableType = "firecracker"
 	qemuHypervisorTableType        = "qemu"
+	quantvisorHypervisorTableType        = "quantvisor"
 
 	// supported proxy component types
 	kataProxyTableType = "kata"
@@ -717,6 +718,9 @@ func updateRuntimeConfigHypervisor(configPath string, tomlConf tomlConfig, confi
 		case qemuHypervisorTableType:
 			config.HypervisorType = vc.QemuHypervisor
 			hConfig, err = newQemuHypervisorConfig(hypervisor)
+		case quantvisorHypervisorTableType:
+			config.HypervisorType = vc.QuantvisorHypervisor
+			hConfig, err = newQemuHypervisorConfig(hypervisor)
 		}
 
 		if err != nil {
diff --git a/virtcontainers/agent.go b/virtcontainers/agent.go
index f8651be..9053757 100644
--- a/virtcontainers/agent.go
+++ b/virtcontainers/agent.go
@@ -204,6 +204,12 @@ type agent interface {
 	// wait specifies that onlineCPUMem is done sync or async
 	onlineCPUMem(cpus uint32, cpuOnly bool, wait bool) error
 
+	// offlineCPU will offline CPUs and Memory inside the Sandbox.
+	// This function should be called after hot unpluging vCPUs.
+	// cpus specifies the number of CPUs that were added and the agent should offline
+	// wait specifies that offlineCPU is done sync or async
+	offlineCPU(cpus uint32, wait bool) error
+
 	// statsContainerGpu will tell the agent to get GPU stats from a container related to a Sandbox
 	statsContainerGpu(sandbox *Sandbox, c Container) (*pb.StatsContainerGpuResponse, error)
 
@@ -240,6 +246,8 @@ type agent interface {
 	// updateInterface will tell the agent to update a nic for an existed Sandbox.
 	updateInterface(inf *vcTypes.Interface) (*vcTypes.Interface, error)
 
+	updateInterfaceHwAddrByName(inf *vcTypes.Interface) (*vcTypes.Interface, error)
+
 	// listInterfaces will tell the agent to list interfaces of an existed Sandbox
 	listInterfaces() ([]*vcTypes.Interface, error)
 
diff --git a/virtcontainers/hypervisor.go b/virtcontainers/hypervisor.go
index 3590f1a..698a5da 100644
--- a/virtcontainers/hypervisor.go
+++ b/virtcontainers/hypervisor.go
@@ -33,6 +33,8 @@ const (
 
 	// MockHypervisor is a mock hypervisor for testing purposes
 	MockHypervisor HypervisorType = "mock"
+
+	QuantvisorHypervisor HypervisorType = "quantvisor"
 )
 
 const (
@@ -115,6 +117,9 @@ func (hType *HypervisorType) Set(value string) error {
 	case "mock":
 		*hType = MockHypervisor
 		return nil
+	case "quantvisor":
+		*hType = QuantvisorHypervisor
+		return nil
 	default:
 		return fmt.Errorf("Unknown hypervisor type %s", value)
 	}
@@ -129,6 +134,8 @@ func (hType *HypervisorType) String() string {
 		return string(FirecrackerHypervisor)
 	case MockHypervisor:
 		return string(MockHypervisor)
+	case QuantvisorHypervisor:
+		return string(QuantvisorHypervisor)
 	default:
 		return ""
 	}
@@ -143,6 +150,8 @@ func newHypervisor(hType HypervisorType) (hypervisor, error) {
 		return &firecracker{}, nil
 	case MockHypervisor:
 		return &mockHypervisor{}, nil
+	case QuantvisorHypervisor:
+		return &quantvisor{}, nil
 	default:
 		return nil, fmt.Errorf("Unknown hypervisor type %s", hType)
 	}
diff --git a/virtcontainers/kata_agent.go b/virtcontainers/kata_agent.go
index 83fe1b0..02ef437 100644
--- a/virtcontainers/kata_agent.go
+++ b/virtcontainers/kata_agent.go
@@ -542,6 +542,15 @@ func (k *kataAgent) updateInterface(ifc *vcTypes.Interface) (*vcTypes.Interface,
 	return nil, err
 }
 
+func (k *kataAgent) updateInterfaceHwAddrByName(ifc *vcTypes.Interface) (*vcTypes.Interface, error) {
+	ifcReq := &grpc.UpdateInterfaceHwAddrByNameRequest{
+		Interface: k.convertToKataAgentInterface(ifc),
+	}
+	_, err := k.sendReq(ifcReq)
+
+	return nil, err
+}
+
 func (k *kataAgent) updateInterfaces(interfaces []*vcTypes.Interface) error {
 	for _, ifc := range interfaces {
 		if _, err := k.updateInterface(ifc); err != nil {
@@ -1619,6 +1628,16 @@ func (k *kataAgent) onlineCPUMem(cpus uint32, cpuOnly bool, wait bool) error {
 	return err
 }
 
+func (k *kataAgent) offlineCPU(cpus uint32, wait bool) error {
+	req := &grpc.OfflineCPURequest{
+		Wait: wait,
+		NbCpus: cpus,
+	}
+
+	_, err := k.sendReq(req)
+	return err
+}
+
 func (k *kataAgent) statsContainerGpu(sandbox *Sandbox, c Container) (*pb.StatsContainerGpuResponse, error) {
 	req := &grpc.StatsContainerGpuRequest{
 		ContainerId: c.id,
@@ -1842,6 +1861,11 @@ func (k *kataAgent) installReqFunc(c *kataclient.AgentClient) {
 		defer cancel()
 		return k.client.UpdateInterface(ctx, req.(*grpc.UpdateInterfaceRequest), opts...)
 	}
+	k.reqHandlers["grpc.UpdateInterfaceHwAddrByNameRequest"] = func(ctx context.Context, req interface{}, opts ...golangGrpc.CallOption) (interface{}, error) {
+		ctx, cancel := context.WithTimeout(ctx, defaultGrpcTimeout)
+		defer cancel()
+		return k.client.UpdateInterfaceHwAddrByName(ctx, req.(*grpc.UpdateInterfaceHwAddrByNameRequest), opts...)
+	}
 	k.reqHandlers["grpc.ListInterfacesRequest"] = func(ctx context.Context, req interface{}, opts ...golangGrpc.CallOption) (interface{}, error) {
 		ctx, cancel := context.WithTimeout(ctx, defaultGrpcTimeout)
 		defer cancel()
@@ -1857,6 +1881,11 @@ func (k *kataAgent) installReqFunc(c *kataclient.AgentClient) {
 		defer cancel()
 		return k.client.OnlineCPUMem(ctx, req.(*grpc.OnlineCPUMemRequest), opts...)
 	}
+	k.reqHandlers["grpc.OfflineCPURequest"] = func(ctx context.Context, req interface{}, opts ...golangGrpc.CallOption) (interface{}, error) {
+		ctx, cancel := context.WithTimeout(ctx, defaultGrpcTimeout)
+		defer cancel()
+		return k.client.OfflineCPU(ctx, req.(*grpc.OfflineCPURequest), opts...)
+	}
 	k.reqHandlers["grpc.ListProcessesRequest"] = func(ctx context.Context, req interface{}, opts ...golangGrpc.CallOption) (interface{}, error) {
 		ctx, cancel := context.WithTimeout(ctx, defaultGrpcTimeout)
 		defer cancel()
diff --git a/virtcontainers/noop_agent.go b/virtcontainers/noop_agent.go
index ad14efe..41034bc 100644
--- a/virtcontainers/noop_agent.go
+++ b/virtcontainers/noop_agent.go
@@ -102,11 +102,20 @@ func (n *noopAgent) onlineCPUMem(cpus uint32, cpuOnly bool, wait bool) error {
 	return nil
 }
 
+// offlineCPU is the Noop agent Container offline CPU implementation. It does nothing.
+func (n *noopAgent) offlineCPU(cpus uint32, wait bool) error {
+	return nil
+}
+
 // updateInterface is the Noop agent Interface update implementation. It does nothing.
 func (n *noopAgent) updateInterface(inf *vcTypes.Interface) (*vcTypes.Interface, error) {
 	return nil, nil
 }
 
+func (n *noopAgent) updateInterfaceHwAddrByName(inf *vcTypes.Interface) (*vcTypes.Interface, error) {
+	return nil, nil
+}
+
 // listInterfaces is the Noop agent Interfaces list implementation. It does nothing.
 func (n *noopAgent) listInterfaces() ([]*vcTypes.Interface, error) {
 	return nil, nil
diff --git a/virtcontainers/quantvisor.go b/virtcontainers/quantvisor.go
new file mode 100644
index 0000000..c818e17
--- /dev/null
+++ b/virtcontainers/quantvisor.go
@@ -0,0 +1,687 @@
+package virtcontainers
+
+import (
+	"context"
+	"fmt"
+	"os"
+	"os/exec"
+	"io/ioutil"
+	"time"
+	"strconv"
+	"strings"
+	"syscall"
+	"path/filepath"
+
+	govmmQemu "github.com/intel/govmm/qemu"
+	"github.com/opentracing/opentracing-go"
+	"github.com/sirupsen/logrus"
+
+	"github.com/kata-containers/runtime/virtcontainers/device/config"
+	"github.com/kata-containers/runtime/virtcontainers/store"
+	"github.com/kata-containers/runtime/virtcontainers/types"
+	vcTypes "github.com/kata-containers/runtime/virtcontainers/pkg/types"
+)
+
+const defaultDummyMac = "22:33:44:aa:bb:"
+const mmioBlkCount = 6
+const mmioNetCount = 2
+
+type quantvisorDev struct {
+	dev     interface{}
+	devType deviceType
+}
+
+type quantvisor struct {
+	id string
+	ctx context.Context
+	sandbox *Sandbox
+	store *store.VCStore
+	config HypervisorConfig
+	socketPath string
+	consolePath string
+	pidFilePath string
+	qmpMonitorCh qmpChannel
+	devices []quantvisorDev
+	HotpluggedVCPUs []CPUDevice
+	mmioBlkSlots [mmioBlkCount]bool
+	mmioNetSlots [mmioNetCount]bool
+}
+
+func (q *quantvisor) Logger() *logrus.Entry {
+	return virtLog.WithField("subsystem", "quantvisor")
+}
+
+func (q *quantvisor) trace(name string) (opentracing.Span, context.Context) {
+	span, ctx := opentracing.StartSpanFromContext(q.ctx, name)
+
+	span.SetTag("subsystem", "hypervisor")
+	span.SetTag("type", "quantvisor")
+
+	return span, ctx
+}
+
+func (q *quantvisor) getKernelCmdLine() string {
+	var params []string
+
+	params = append(params, "pci=off")
+	params = append(params, "reboot=k")
+	params = append(params, "panic=1")
+	params = append(params, "iommu=off")
+	params = append(params, "acpi=off")
+	params = append(params, "quiet")
+	params = append(params, "agent.use_vsock=" + strconv.FormatBool(q.config.UseVSock))
+	params = append(params, SerializeParams(q.config.KernelParams, "=")...)
+
+	return strings.Join(params, " ")
+}
+
+func (q *quantvisor) hypervisorConfig() HypervisorConfig {
+	return q.config
+}
+
+func (q *quantvisor) createSandbox(ctx context.Context, id string, hypervisorConfig *HypervisorConfig, vcstore *store.VCStore) error {
+	q.ctx = ctx
+
+	span, _ := q.trace("createSandbox")
+	defer span.Finish()
+
+	sandbox, err := globalSandboxList.lookupSandbox(id)
+	if err != nil {
+		q.Logger().Error("createSandbox: get sandbox failed")
+		return err
+	}
+
+	q.id = id
+	q.sandbox = sandbox
+	q.store = vcstore
+	q.config = *hypervisorConfig
+	q.socketPath = filepath.Join(store.RunVMStoragePath, id, "qmp.sock")
+	q.consolePath = filepath.Join(store.RunVMStoragePath, id, "console.sock")
+	q.pidFilePath = filepath.Join(store.RunVMStoragePath, id, "pid")
+	q.qmpMonitorCh = qmpChannel{
+		ctx:  q.ctx,
+		path: q.socketPath,
+	}
+
+	return err
+}
+
+func (q *quantvisor) waitSandBoxStarted(timeout int) error {
+	timeStart := time.Now()
+	for {
+		err := q.qmpSetup()
+		if err == nil {
+			break
+		}
+
+		if int(time.Since(timeStart).Seconds()) > timeout {
+			return fmt.Errorf("Failed to connect to QuantVisor instance (timeout %ds): %v", timeout, err)
+		}
+
+		time.Sleep(time.Duration(50) * time.Millisecond)
+	}
+
+	if err := q.qmpMonitorCh.qmp.ExecuteQMPCapabilities(q.qmpMonitorCh.ctx); err != nil {
+		q.Logger().WithError(err).Error(qmpCapErrMsg)
+		return err
+	}
+
+	return nil
+}
+
+func (q *quantvisor) startSandbox(timeout int) error {
+	span, _ := q.trace("startSandbox")
+	defer span.Finish()
+
+	var params []string
+	params = append(params, "-name " + fmt.Sprintf("sandbox-%s", q.id))
+	params = append(params, "-api-channel unix:" + q.socketPath)
+	params = append(params, "-pidfile " + q.pidFilePath)
+
+	if kernelPath, err := q.config.KernelAssetPath(); err == nil {
+		params = append(params, "-kernel " + kernelPath)
+	}
+
+	if initrdPath, err := q.config.InitrdAssetPath(); err == nil {
+		params = append(params, "-initrd " + initrdPath)
+	}
+
+	params = append(params, "-append " + q.getKernelCmdLine())
+	params = append(params, fmt.Sprintf("-smp %d,maxcpus=%d", q.config.NumVCPUs, q.config.DefaultMaxVCPUs))
+	params = append(params, fmt.Sprintf("-m %d", q.config.MemorySize * 1024 * 1024))
+	params = append(params, fmt.Sprintf("-chardev id=charconsole0,path=%s", q.consolePath))
+
+	// add devices to cmdline
+	for _, d := range q.devices {
+		switch v := d.dev.(type) {
+		case Endpoint:
+			name := v.Name()
+			mac := v.HardwareAddr()
+			tapName := v.NetworkPair().TapInterface.TAPIface.Name
+			params = append(params, fmt.Sprintf("-net id=%s,mac=%s,host_dev_name=%s", name, mac, tapName))
+		case config.BlockDrive:
+			id := v.ID
+			path := v.File
+			params = append(params, fmt.Sprintf("-drive id=%s,file=%s", id, path))
+		case kataVSOCK:
+			guestCid := v.contextID
+			v.vhostFd.Close()
+			params = append(params, fmt.Sprintf("-device vsock,id=vsock-id,guest-cid=%d", guestCid))
+		default:
+			q.Logger().Error("Adding device: un-support device type")
+		}
+	}
+
+	// daemonize and logfile
+	params = append(params, "-daemonize")
+
+	q.Logger().Info("VM start with params: ", strings.Join(params, " "))
+
+	dir := filepath.Join(store.RunVMStoragePath, q.id)
+	err := os.MkdirAll(dir, store.DirMode)
+	if err != nil {
+		return err
+	}
+	defer func() {
+		if err != nil {
+			if err := os.RemoveAll(dir); err != nil {
+				q.Logger().WithError(err).Error("Fail to clean up vm dir %s", dir)
+			}
+		}
+	}()
+
+	binPath, err := q.config.HypervisorAssetPath()
+	if err != nil {
+		q.Logger().WithField("Fail to get hypervisor bin path", err).Error()
+		return err
+	}
+
+	cmd := exec.CommandContext(q.ctx, binPath, params...)
+	if err := cmd.Run(); err != nil {
+		q.Logger().WithField("Error starting hypervisor, check the params", err).Error()
+		return err
+	}
+
+	if err = q.waitSandBoxStarted(timeout); err != nil {
+		return err
+	}
+
+	return nil
+}
+
+func (q *quantvisor) stopSandbox(force bool) error {
+	span, _ := q.trace("stopSandbox")
+	defer span.Finish()
+
+	defer func () {
+		dir := filepath.Join(store.RunVMStoragePath, q.id)
+		link, _ := filepath.EvalSymlinks(dir)
+
+		if err := os.RemoveAll(dir); err != nil {
+			q.Logger().WithError(err).Warnf("failed to remove vm path %s", dir)
+		}
+
+		if link != dir && link != "" {
+			if err := os.RemoveAll(link); err != nil {
+				q.Logger().WithError(err).WithField("link", link).Warn("failed to remove vm path link %s", link)
+			}
+		}
+	}()
+
+	if !force {
+		err := q.qmpSetup()
+		if err != nil {
+			return err
+		}
+
+		err = q.qmpMonitorCh.qmp.ExecuteQuit(q.qmpMonitorCh.ctx)
+		if err != nil {
+			q.Logger().WithError(err).Error("Fail to execute qmp QUIT")
+			return err
+		}
+	} else {
+		if q.pid() > 0 {
+			syscall.Kill(q.pid(), syscall.SIGKILL)
+		}
+	}
+	return nil
+}
+
+func (q *quantvisor) pauseSandbox() error {
+	return nil
+}
+
+func (q *quantvisor) saveSandbox() error {
+	return nil
+}
+
+func (q *quantvisor) resumeSandbox() error {
+	return nil
+}
+
+func (q *quantvisor) addDevice(devInfo interface{}, devType deviceType) error {
+	dev := quantvisorDev {
+		dev:     devInfo,
+		devType: devType,
+	}
+	q.devices = append(q.devices, dev)
+
+	return nil
+}
+
+func (q *quantvisor) updateVMInterfaceHwAddr(Name string, HwAddr string) {
+	inf := &vcTypes.Interface{
+		Name: Name,
+		HwAddr: HwAddr,
+		IPAddresses: []*vcTypes.IPAddress{},
+		PciAddr: "",
+	}
+
+	_, err := q.sandbox.agent.updateInterfaceHwAddrByName(inf)
+	if err != nil {
+		q.Logger().WithError(err).Error("updateInterfaceHwAddrByName failed")
+	}
+}
+
+func (q *quantvisor) getDevSlot(Name string, isPut bool) (slot int, err error){
+	Name = filepath.Base(strings.ToLower(Name))
+
+	if strings.HasPrefix(Name, "eth") {
+		idxStr := strings.TrimPrefix(Name, "eth")
+		if idxStr == Name {
+			return 0, fmt.Errorf("Could not get idx from Name %q", Name)
+		}
+
+		idx, err := strconv.Atoi(idxStr)
+		if err != nil {
+			return 0, fmt.Errorf("Could not convert to index from Str %q", idxStr)
+		}
+
+		if !isPut && q.mmioNetSlots[idx] {
+			return 0, fmt.Errorf("getDevSlot failed, the slot is being used %q", idxStr)
+		}
+		q.mmioNetSlots[idx] = !isPut
+
+		return idx, nil
+	} else if strings.HasPrefix(Name, "vd") {
+		charStr := strings.TrimPrefix(Name, "vd")
+		if charStr == Name {
+			return 0, fmt.Errorf("Could not get idx from Name %q", Name)
+		}
+
+		char := []rune(charStr)
+		idx := int(char[0] - 'a')
+
+		if !isPut && q.mmioBlkSlots[idx] {
+			return 0, fmt.Errorf("getDevSlot failed, the slot is being used %q", charStr)
+		}
+		q.mmioBlkSlots[idx] = !isPut
+
+		return idx, nil
+	}
+
+	return 0, fmt.Errorf("getDevSlot failed, Name is invalid %q", Name)
+}
+
+func (q *quantvisor) hotplugNet(endpoint Endpoint, op operation) (err error) {
+	err = q.qmpSetup()
+	if err != nil {
+		return err
+	}
+	var tap TapInterface
+
+	switch endpoint.Type() {
+	case VethEndpointType:
+		drive := endpoint.(*VethEndpoint)
+		tap = drive.NetPair.TapInterface
+	case TapEndpointType:
+		drive := endpoint.(*TapEndpoint)
+		tap = drive.TapInterface
+	default:
+		return fmt.Errorf("this endpoint is not supported")
+	}
+
+	switch op {
+	case addDevice:
+		var (
+			VMFdNames    []string
+			VhostFdNames []string
+		)
+		for i, VMFd := range tap.VMFds {
+			fdName := fmt.Sprintf("fd%d", i)
+			if err := q.qmpMonitorCh.qmp.ExecuteGetFD(q.qmpMonitorCh.ctx, fdName, VMFd); err != nil {
+				return err
+			}
+			VMFdNames = append(VMFdNames, fdName)
+		}
+		for i, VhostFd := range tap.VhostFds {
+			fdName := fmt.Sprintf("vhostfd%d", i)
+			if err := q.qmpMonitorCh.qmp.ExecuteGetFD(q.qmpMonitorCh.ctx, fdName, VhostFd); err != nil {
+				return err
+			}
+			VhostFd.Close()
+			VhostFdNames = append(VhostFdNames, fdName)
+		}
+
+		slot, err := q.getDevSlot(endpoint.Name(), false)
+		if err != nil {
+			return fmt.Errorf("Could not get unused slot for %q", endpoint.Name())
+		}
+
+		if len(VMFdNames) != 0 || len(VhostFdNames) != 0 {
+			q.qmpMonitorCh.qmp.ExecuteNetdevAddByFds(q.qmpMonitorCh.ctx, "tap", tap.ID, VMFdNames, VhostFdNames)
+		} else {
+			q.qmpMonitorCh.qmp.ExecuteNetdevAdd(q.qmpMonitorCh.ctx, "tap", tap.ID, tap.TAPIface.Name, "no", "no", "on", 0)
+		}
+		q.qmpMonitorCh.qmp.ExecuteNetPCIDeviceAdd(q.qmpMonitorCh.ctx, tap.Name, tap.ID, endpoint.HardwareAddr(), fmt.Sprintf("%d", slot), "", "", 0, false)
+
+		// update vm interface
+		q.updateVMInterfaceHwAddr(endpoint.Name(), endpoint.HardwareAddr())
+		return nil
+	default:
+		if err := q.qmpMonitorCh.qmp.ExecuteDeviceDel(q.qmpMonitorCh.ctx, tap.ID); err != nil {
+			return err
+		}
+		if err := q.qmpMonitorCh.qmp.ExecuteNetdevDel(q.qmpMonitorCh.ctx, tap.ID); err != nil {
+			return err
+		}
+
+		slot, err := q.getDevSlot(endpoint.Name(), true)
+		if err != nil {
+			slot = 0
+		}
+
+		// clear vm interface
+		q.updateVMInterfaceHwAddr(endpoint.Name(), defaultDummyMac + fmt.Sprintf("%02x", slot))
+		return nil
+	}
+}
+
+func (q *quantvisor) hotplugBlk(drive *config.BlockDrive, op operation) (err error) {
+	err = q.qmpSetup()
+	if err != nil {
+		return err
+	}
+
+	switch op {
+	case addDevice:
+		driver := "virtio-blk-pci"
+		slot, err := q.getDevSlot(drive.VirtPath, false)
+		if err != nil {
+			return fmt.Errorf("Could not get unused slot for %q", drive.VirtPath)
+		}
+
+		q.qmpMonitorCh.qmp.ExecuteBlockdevAdd(q.qmpMonitorCh.ctx, drive.File, drive.ID)
+		q.qmpMonitorCh.qmp.ExecutePCIDeviceAdd(q.qmpMonitorCh.ctx, drive.ID, drive.ID, driver, fmt.Sprintf("%d", slot), "", "", true, false)
+		return nil
+	default:
+		if err := q.qmpMonitorCh.qmp.ExecuteDeviceDel(q.qmpMonitorCh.ctx, drive.ID); err != nil {
+			return err
+		}
+
+		if err := q.qmpMonitorCh.qmp.ExecuteBlockdevDel(q.qmpMonitorCh.ctx, drive.ID); err != nil {
+			return err
+		}
+
+		q.getDevSlot(drive.VirtPath, true)
+		return nil
+	}
+}
+
+func (q *quantvisor) hotplugCPUs(vcpus uint32, op operation) (uint32, error) {
+	if vcpus == 0 {
+		q.Logger().Warnf("cannot hotplug 0 vCPUs")
+		return 0, nil
+	}
+
+	err := q.qmpSetup()
+	if err != nil {
+		return 0, err
+	}
+
+	if op == addDevice {
+		currentVCPUs := q.config.NumVCPUs + uint32(len(q.HotpluggedVCPUs))
+
+		if currentVCPUs + vcpus > q.config.DefaultMaxVCPUs {
+			q.Logger().Warnf("Cannot hotlug %d CPUs, currently this SB has %d CPUs and the maximum amount of CPUs is %d",
+				vcpus, currentVCPUs, q.config.DefaultMaxVCPUs)
+			vcpus = q.config.DefaultMaxVCPUs - currentVCPUs
+		}
+
+		if vcpus == 0 {
+			q.Logger().Warnf("maximum number of vCPUs '%d' has been reached", q.config.DefaultMaxVCPUs)
+			return 0, nil
+		}
+
+		// get the list of hotpluggable CPUs
+		hotpluggableVCPUs, err := q.qmpMonitorCh.qmp.ExecuteQueryHotpluggableCPUs(q.qmpMonitorCh.ctx)
+		if err != nil {
+			return 0, fmt.Errorf("failed to query hotpluggable CPUs: %v", err)
+		}
+
+		var hotpluggedVCPUs uint32
+		for _, hc := range hotpluggableVCPUs {
+			if hc.QOMPath != "" {
+				continue
+			}
+
+			driver := hc.Type
+			cpuID := fmt.Sprintf("cpu-%d", uint32(len(q.HotpluggedVCPUs))+q.config.NumVCPUs)
+			socketID := fmt.Sprintf("%d", hc.Properties.Socket)
+			coreID := fmt.Sprintf("%d", hc.Properties.Core)
+			threadID := fmt.Sprintf("%d", hc.Properties.Thread)
+
+			if err := q.qmpMonitorCh.qmp.ExecuteCPUDeviceAdd(q.qmpMonitorCh.ctx, driver, cpuID, socketID, coreID, threadID, romFile); err != nil {
+				continue
+			}
+
+			q.HotpluggedVCPUs = append(q.HotpluggedVCPUs, CPUDevice{cpuID})
+
+			hotpluggedVCPUs++
+			if hotpluggedVCPUs == vcpus {
+				return vcpus, nil
+			}
+		}
+		return hotpluggedVCPUs, fmt.Errorf("failed to hot add vCPUs: only %d vCPUs of %d were added", hotpluggedVCPUs, vcpus)
+	}
+
+	hotpluggedVCPUs := uint32(len(q.HotpluggedVCPUs))
+
+	if vcpus > hotpluggedVCPUs {
+		return 0, fmt.Errorf("Unable to remove %d CPUs, currently there are only %d hotpluggabled CPUs", vcpus, hotpluggedVCPUs)
+	}
+
+	for i := uint32(0); i < vcpus; i++ {
+		cpu := q.HotpluggedVCPUs[len(q.HotpluggedVCPUs)-1]
+		if err := q.qmpMonitorCh.qmp.ExecuteDeviceDel(q.qmpMonitorCh.ctx, cpu.ID); err != nil {
+			return i, fmt.Errorf("failed to hotunplug CPUs, only %d CPUs were hotunplugged: %v", i, err)
+		}
+
+		q.HotpluggedVCPUs = q.HotpluggedVCPUs[:len(q.HotpluggedVCPUs)-1]
+	}
+
+	return vcpus, nil
+}
+
+func (q *quantvisor) hotplugAddDevice(devInfo interface{}, devType deviceType) (interface{}, error) {
+	span, _ := q.trace("hotplugAddDevice")
+	defer span.Finish()
+
+	switch devType {
+	case netDev:
+		q.hotplugNet(devInfo.(Endpoint), addDevice)
+	case blockDev:
+		q.hotplugBlk(devInfo.(*config.BlockDrive), addDevice)
+	case cpuDev:
+		return q.hotplugCPUs(devInfo.(uint32), addDevice)
+	default:
+		return nil, fmt.Errorf("cannot hotplug device: unsupported device type '%v'", devType)
+	}
+
+	return nil, nil
+}
+
+func (q *quantvisor) hotplugRemoveDevice(devInfo interface{}, devType deviceType) (interface{}, error) {
+	span, _ := q.trace("hotplugRemoveDevice")
+	defer span.Finish()
+
+	switch devType {
+	case netDev:
+		q.hotplugNet(devInfo.(Endpoint), removeDevice)
+	case blockDev:
+		q.hotplugBlk(devInfo.(*config.BlockDrive), removeDevice)
+	case cpuDev:
+		return q.hotplugCPUs(devInfo.(uint32), removeDevice)
+	default:
+		return nil, fmt.Errorf("cannot hotplug device: unsupported device type '%v'", devType)
+	}
+
+	return nil, nil
+}
+
+func (q *quantvisor) resizeMemory(reqMemMB uint32, memoryBlockSizeMB uint32, probe bool) (uint32, memoryDevice, error) {
+	return 0, memoryDevice{}, nil
+}
+
+func (q *quantvisor) resizeVCPUs(reqVCPUs uint32) (currentVCPUs uint32, newVCPUs uint32, err error) {
+	currentVCPUs = q.config.NumVCPUs + uint32(len(q.HotpluggedVCPUs))
+	newVCPUs = currentVCPUs
+	switch {
+	case currentVCPUs < reqVCPUs:
+		addCPUs := reqVCPUs - currentVCPUs
+		data, err := q.hotplugAddDevice(addCPUs, cpuDev)
+		if err != nil {
+			return currentVCPUs, newVCPUs, err
+		}
+		vCPUsAdded, ok := data.(uint32)
+		if !ok {
+			return currentVCPUs, newVCPUs, fmt.Errorf("Could not get the vCPUs added, got %+v", data)
+		}
+		newVCPUs += vCPUsAdded
+	case currentVCPUs > reqVCPUs:
+		removeCPUs := currentVCPUs - reqVCPUs
+		data, err := q.hotplugRemoveDevice(removeCPUs, cpuDev)
+		if err != nil {
+			return currentVCPUs, newVCPUs, err
+		}
+		VCPUsRemoved, ok := data.(uint32)
+		if !ok {
+			return currentVCPUs, newVCPUs, fmt.Errorf("Could not get the vCPUs removed, got %+v", data)
+		}
+		newVCPUs -= VCPUsRemoved
+	}
+	return currentVCPUs, newVCPUs, nil
+}
+
+func (q *quantvisor) getSandboxConsole(id string) (string, error) {
+	return q.consolePath, nil
+}
+
+func (q *quantvisor) getMemorySize() uint32 {
+	return 0
+}
+
+func (q *quantvisor) disconnect() {
+	span, _ := q.trace("disconnect")
+	defer span.Finish()
+
+	q.qmpTeardown()
+}
+
+func (q *quantvisor) capabilities() types.Capabilities {
+	span, _ := q.trace("capabilities")
+	defer span.Finish()
+
+	var caps types.Capabilities
+	caps.SetFsSharingUnsupported()
+	caps.SetBlockDeviceHotplugSupport()
+	caps.SetCpuOfflineSupported()
+
+	return caps
+}
+
+func (q *quantvisor) qmpTeardown() {
+	if q.qmpMonitorCh.qmp != nil {
+		q.qmpMonitorCh.qmp.Shutdown()
+		<-q.qmpMonitorCh.disconn
+		q.qmpMonitorCh.qmp = nil
+		q.qmpMonitorCh.disconn = nil
+	}
+}
+
+func (q *quantvisor) qmpSetup() error {
+	q.qmpTeardown()
+
+	cfg := govmmQemu.QMPConfig{Logger: newQMPLogger()}
+
+	// Auto-closed by QMPStart().
+	disconnectCh := make(chan struct{})
+
+	qmp, _, err := govmmQemu.QMPStart(q.qmpMonitorCh.ctx, q.qmpMonitorCh.path, cfg, disconnectCh)
+	if err != nil {
+		q.Logger().WithError(err).Error("Failed to connect to QuantVisor instance")
+		return err
+	}
+
+	q.qmpMonitorCh.qmp = qmp
+	q.qmpMonitorCh.disconn = disconnectCh
+
+	return nil
+}
+
+func (q *quantvisor) getThreadIDs() (vcpuThreadIDs, error) {
+	span, _ := q.trace("getThreadIDs")
+	defer span.Finish()
+
+	tid := vcpuThreadIDs{}
+	if err := q.qmpSetup(); err != nil {
+		return tid, err
+	}
+
+	cpuInfos, err := q.qmpMonitorCh.qmp.ExecQueryCpus(q.qmpMonitorCh.ctx)
+	if err != nil {
+		q.Logger().WithError(err).Error("Failed to query cpu infos")
+		return tid, err
+	}
+
+	tid.vcpus = make(map[int]int, len(cpuInfos))
+	for _, i := range cpuInfos {
+		if i.ThreadID > 0 {
+			tid.vcpus[i.CPU] = i.ThreadID
+		}
+	}
+	return tid, nil
+}
+
+func (q *quantvisor) cleanup() error {
+	span, _ := q.trace("cleanup")
+	defer span.Finish()
+
+	q.qmpTeardown()
+
+	return nil
+}
+
+func (q *quantvisor) pid() int {
+	data, err := ioutil.ReadFile(q.pidFilePath)
+	if err != nil {
+		q.Logger().WithError(err).Error("Could not read qemu pid file")
+		return 0
+	}
+
+	pid, err := strconv.Atoi(strings.Trim(string(data), "\n\t "))
+	if err != nil {
+		q.Logger().WithError(err).Error("Could not convert pid string to int")
+		return 0
+	}
+
+	return pid
+}
+
+func (q *quantvisor) fromGrpc(ctx context.Context, hypervisorConfig *HypervisorConfig, store *store.VCStore, j []byte) error {
+	return nil
+}
+
+func (q *quantvisor) toGrpc() ([]byte, error) {
+	return nil, nil
+}
diff --git a/virtcontainers/sandbox.go b/virtcontainers/sandbox.go
index 465e8ea..e6e466d 100644
--- a/virtcontainers/sandbox.go
+++ b/virtcontainers/sandbox.go
@@ -2247,6 +2247,20 @@ func (s *Sandbox) updateResources() error {
 	}
 	s.Logger().Debugf("Sandbox CPUs: %d", newCPUs)
 
+	caps := s.hypervisor.capabilities()
+	if caps.IsCpuOfflineSupprorted() {
+		// The CPUs were decreased, ask agent to offline them
+		if oldCPUs > newCPUs {
+			vcpusDeled := oldCPUs - newCPUs
+			if err := s.agent.offlineCPU(vcpusDeled, false); err != nil {
+				return err
+			}
+		}
+
+		// Unsupported memory update, return directly
+		return nil
+	}
+
 	// Update Memory
 	s.Logger().WithField("memory-sandbox-size-byte", sandboxMemoryByte).Debugf("Request to hypervisor to update memory")
 
diff --git a/virtcontainers/types/capabilities.go b/virtcontainers/types/capabilities.go
index fbd86a6..4470861 100644
--- a/virtcontainers/types/capabilities.go
+++ b/virtcontainers/types/capabilities.go
@@ -10,6 +10,7 @@ const (
 	blockDeviceHotplugSupport
 	multiQueueSupport
 	fsSharingUnsupported
+	cpuOfflineSupported
 )
 
 // Capabilities describe a virtcontainers hypervisor capabilities
@@ -57,3 +58,13 @@ func (caps *Capabilities) IsFsSharingSupported() bool {
 func (caps *Capabilities) SetFsSharingUnsupported() {
 	caps.flags |= fsSharingUnsupported
 }
+
+// IsCpuOfflineSupported tells if an hypervisor supports offline cpu by agent.
+func (caps *Capabilities) IsCpuOfflineSupprorted() bool {
+	return caps.flags&cpuOfflineSupported != 0
+}
+
+// SetCpuOfflineSupported sets the cpu offline after hot-unplug capability to true.
+func (caps *Capabilities) SetCpuOfflineSupported() {
+	caps.flags |= cpuOfflineSupported
+}
diff --git a/virtcontainers/vm.go b/virtcontainers/vm.go
index 08100a7..5b8bb70 100644
--- a/virtcontainers/vm.go
+++ b/virtcontainers/vm.go
@@ -380,6 +380,17 @@ func (v *VM) OnlineCPUMemory() error {
 	return err
 }
 
+// OfflineCPU puts the hotplugged CPU offline.
+func (v *VM) OfflineCPU() error {
+	v.logger().Infof("offline CPU %d", v.cpuDelta)
+	err := v.agent.offlineCPU(v.cpuDelta, false)
+	if err == nil {
+		v.cpuDelta = 0
+	}
+
+	return err
+}
+
 // ReseedRNG adds random entropy to guest random number generator
 // and reseeds it.
 func (v *VM) ReseedRNG() error {
-- 
2.9.3

